



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PHP递归目录的5种方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PHP递归目录的5种方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 01:05:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">&lt;?php<br />
//方法一：使用glob循环

function myscandir1($path, &amp;$arr) {

    foreach (glob($path) as $file) {<br />
        if (is_dir($file)) {<br />
            myscandir1($file . '/*', $arr);<br />
        } else {

            $arr[] = realpath($file);<br />
        }<br />
    }<br />
}

//方法二：使用dir &amp;&amp; read循环<br />
function myscandir2($path, &amp;$arr) {

    $dir_handle = dir($path);<br />
    while (($file = $dir_handle-&gt;read()) !== false) {

        $p = realpath($path . '/' . $file);<br />
        if ($file != "." &amp;&amp; $file != "..") {<br />
            $arr[] = $p;<br />
        }

        if (is_dir($p) &amp;&amp; $file != "." &amp;&amp; $file != "..") {<br />
            myscandir2($p, $arr);<br />
        }<br />
    }<br />
}

//方法三：使用opendir &amp;&amp; readdir循环<br />
function myscandir3($path, &amp;$arr) {

    $dir_handle = opendir($path);<br />
    while (($file = readdir($dir_handle)) !== false) {

        $p = realpath($path . '/' . $file);<br />
        if ($file != "." &amp;&amp; $file != "..") {<br />
            $arr[] = $p;<br />
        }<br />
        if (is_dir($p) &amp;&amp; $file != "." &amp;&amp; $file != "..") {<br />
            myscandir3($p, $arr);<br />
        }<br />
    }<br />
}

//方法四：使用scandir循环<br />
function myscandir4($path, &amp;$arr) {

    $dir_handle = scandir($path);<br />
    foreach ($dir_handle as $file) {

        $p = realpath($path . '/' . $file);<br />
        if ($file != "." &amp;&amp; $file != "..") {<br />
            $arr[] = $p;<br />
        }<br />
        if (is_dir($p) &amp;&amp; $file != "." &amp;&amp; $file != "..") {<br />
            myscandir4($p, $arr);<br />
        }<br />
    }<br />
}

//方法五：使用SPL循环<br />
function myscandir5($path, &amp;$arr) {

    $iterator = new DirectoryIterator($path);<br />
    foreach ($iterator as $fileinfo) {

        $file = $fileinfo-&gt;getFilename();<br />
        $p = realpath($path . '/' . $file);<br />
        if (!$fileinfo-&gt;isDot()) {<br />
            $arr[] = $p;<br />
        }<br />
        if ($fileinfo-&gt;isDir() &amp;&amp; !$fileinfo-&gt;isDot()) {<br />
            myscandir5($p, $arr);<br />
        }<br />
    }<br />
}

//可以用xdebug测试运行时间<br />
myscandir1('./Code',$arr1);//0.164010047913<br />
myscandir2('./Code',$arr2);//0.243014097214<br />
myscandir3('./Code',$arr3);//0.233012914658<br />
myscandir4('./Code',$arr4);//0.240014076233<br />
myscandir5('./Code',$arr5);//0.329999923706 

//需要安装xdebug<br />
echo xdebug_time_index(), "\n";<br />
?&gt;
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv27j19.html">lintcode 最长上升连续子序列 II&lpar;二维最长上升连续序列&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96dwoy8.html">i2c协议简要分析（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93mrvz8.html">IOS的UI基础01</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mn60eq.html">net 中捕获摄像头视频的方式及对比&lpar;How to Capture Camera Video via &period;Net&rpar; （转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02rg0q.html">java如何得到GET和POST请求URL和参数列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okoz2l9.html">c语言学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xe3lv8.html">plugin</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mkwreq.html">开发反模式 - SQL注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kwzzz9.html">使用jquery-qrcode在页面上生成二维码&comma;支持中文</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pvkw48.html">Python科学计算库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1j30pq.html">API权限设计总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gpxmeq.html">BZOJ1969 航线规划</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wjdjnq.html">linux  安装 SVN  server</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wdkerq.html">&ast;&ast;&ast;&ast;&ast;&ast; 三十 &ast;&ast;&ast;&ast;&ast;&ast;、软设笔记【计算机体系结构】-循环冗余校验码（CRC）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2z012q.html">POJ1611-The Suspects-并查集</a>
		</li>
						<li><a href="https://www.batexi.com/a/95ge5pzq.html">uImage是什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r36348.html">python可变类型和不可变类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1z321q.html">unity延时方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93px60r8.html">mysql5&period;7主从复制--在线变更复制类型【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn1p54q.html">通过Chrome的inspect对手机webview进行调试</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/953yojz8.html">sqlserver 创建用户仅仅能訪问指定视图</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpkwx49.html">Python Post img</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kvop3q.html">Tomcat安装笔记（on Mac）</a>
			</li>
						<li><a href="https://www.batexi.com/a/953y6jm8.html">Jungle Roads&lowbar;hdu&lowbar;1301&lpar;prim算法&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvxp0dq.html">Lichee （五） sysconfig1&period;fex 配置系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmgkd49.html">Cesium中Homebutton改变默认跳转位置 【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjl6ejq.html">App优化 Systrace</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn0r63q.html">C&num; 的三种序列化方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvxe7gq.html">js实现手机页面定位</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p2goeq.html">hdu 4491 Windmill Animation</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
